from datetime import datetime
from pydantic import BaseModel
from hatchet_sdk import Context

from knoc.hatchet_client import hatchet
from knoc import __version__


class SimpleInput(BaseModel):
    friendly: bool = True
    name: str | None = None

    def foo(self) -> str:
        greeting = "Ahoy" if self.friendly else "Hello"
        who = self.name or "John Doe"
        return f"{greeting}, {who}!"


class SimpleOutput(BaseModel):
    message: str
    version: str
    time: datetime


foo_wf = hatchet.workflow(
    name="Foo",
    description="Does nothing else but give time",
    input_validator=SimpleInput,
    version=__version__,
)


@foo_wf.task()
async def foo_task(input: SimpleInput, ctx: Context) -> SimpleOutput:
    ctx.log("Foo!")
    return SimpleOutput(message=input.foo(), version=__version__, time=datetime.now())
